/*
 *  キャラクターコード一覧ビューアー on JAVA version 1.100
 *
 *					(C) Copyright 2009 Hiroshi Kuze.
*/


import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.text.*;

/*
 * <applet code="chara_table.class" width=536 height=614></applet>
 */

public class chara_table extends Applet implements Runnable {
	public static final String TitleFrame = "キャラクターコード一覧ビューアー on JAVA";
	public static final String Version = "1.100";
	private static final long serialVersionUID = 1L;
	public static final int x = 536;
	public static final int y = 614;	// メニュー文+22pix追加 height 592
	public static final int MaxLine = 35;

	public static StringTable ta;			// 表示管理
	public static char code;				// キーから受け取った文字コード
	public static MenuListener menulist;	// メニュー準備
	public static int mode;			// 処理モード(0…Normal / 1…Reset / 2…Version)
	public static Thread MainLoop = null;

	// 変数等初期化
	public chara_table() {
		ta = new StringTable(MaxLine);
		code = 0;
		mode = 0;
		setFont(new Font("monospaced",Font.PLAIN,16));
		
		addKeyListener(new Listen());
		MainLoop = new Thread(this);
	}
	
	/*
	 * アプレット処理関連
	 */
	public void init(){
		setBackground(new Color( 1.0F, 1.0F, 1.0F));
		
		ViewCharacterList();
		
		MainLoop.start();
	} 

	/*
	 * アプリケーション処理
	 */
	public static void main(String args[]) {
		Frame f = new Frame(TitleFrame);
		f.setResizable(false);
		
		Applet a = new chara_table();
		f.setSize(x, y);
		f.add(a);
		
		// アイコン
		Image icon = Toolkit.getDefaultToolkit().getImage("icon_chara_table.gif");
		f.setIconImage(icon);
		
		// メニューバー
		menulist = new MenuListener();
		menulist.setMenu(f);
		
		
		ViewCharacterList();
		
		f.setVisible(true);
		
		f.addWindowListener(new ExitListener());

		MainLoop.start();
	}
	
	/*
	 * メインルーチン
	 */
	public void run() {
		while(true) {
			repaint();
			try {
				Thread.sleep(10);
			} catch(InterruptedException e) {}
		}
	}
	
	/*
	 * 描写部分
	 * ダブルバッファリング参考:
	 * http://www.javadrive.jp/applet/thread/index8.html
	 */
	public void paint(Graphics gc) {
		Dimension size = getSize();
		Image ScreenImage = createImage(size.width, size.height);
		Graphics ScreenBuffer = ScreenImage.getGraphics();
		
		SearchCharacter();
		try {
			menulist.runMenu(ta);
		} catch(NullPointerException e) {}
		
		ScreenBuffer.setColor(Color.white);
		ScreenBuffer.fillRect(0, 0, x, y);
		ScreenBuffer.setColor(Color.black);
		for(int i = 0; i <= ta.getMaxLine(); i++) {
			String Line = ta.getLine(i);
			int x = 0;
			
			for(int j = 0; j < Line.length(); j++) {
				ScreenBuffer.drawString(String.valueOf(Line.charAt(j)), x, i*16);
				x = x + ((Line.charAt(j) > 0x00ff) ? 16: 8);
			}
		}
		
		gc.drawImage(ScreenImage, 0, 0, this);
	}
	
	public void update(Graphics gc) {
		paint(gc);
	}
	
	// キャラクターリストの一覧
	public static void ViewCharacterList() {
		DecimalFormat fm = new DecimalFormat();
		char i;
		
		ta.setNewline("== キャラクターコード一覧ビューアー on Java ==");
		ta.setNewline("				(C) Copyright 2009 Hiroshi Kuze.");
		ta.setNewline("");
		ta.setNewline("");

		ta.setNewline("---   0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15");
		
		fm.applyPattern("000");
		
		for(i=(char) 32;i<(char) 256;i=(char) (i+15)) {
			ta.setNewline(fm.format((int) i)+"   "+((char) (i+ 0))
											+"  "+((char) (i+ 1))
											+"  "+((char) (i+ 2))
											+"  "+((char) (i+ 3))
											+"  "+((char) (i+ 4))
											+"  "+((char) (i+ 5))
											+"  "+((char) (i+ 6))
											+"  "+((char) (i+ 7))
											+"  "+((char) (i+ 8))
											+"  "+((char) (i+ 9))
											+"  "+((char) (i+10))
											+"  "+((char) (i+11))
											+"  "+((char) (i+12))
											+"  "+((char) (i+13))
											+"  "+((char) (i+14))
											+"  "+((char) (i+15)));
		}
		
		ta.setNewline("");
		ta.setNewline("");
		ta.setNewline("キャラクターコードを調べたい文字を入力してください。");
		ta.setNewline("");
	}
	
	// 入力されたキャラクターコード情報を表示用に整える
	public static void SearchCharacter() {
		if(code > 0) {
			String Hex = " (toHexString: "+Integer.toHexString(code)+")";
			ta.setNewline("input : "+code);
			switch(code) {
			case   3: ta.setNewline("TC3(ETX) 3 (Ctrl+C)"+Hex);		break;
			case   7: ta.setNewline("BEL 7"+Hex);					break;
			case   8: ta.setNewline("FEO(BS) 13 (Backspace)"+Hex);	break;
			case  10: ta.setNewline("FR2(LF) 10 (Enter)"+Hex);		break;
			case  13: ta.setNewline("FE5(CR) 13 (Enter)"+Hex);				break;
			case  27: ta.setNewline("ESC 27 (Esc)"+Hex);			break;
			case  32: ta.setNewline("SP 32 (Space)"+Hex);		break;
			case 127: ta.setNewline("DEL 127 (Delete)"+Hex);		break;
			default:
				ta.setNewline(code+" "+((int) code)+Hex);
				break;
			}
		}
		
		code = 0;
	}
	
	class Listen extends KeyAdapter {
		public void keyPressed(KeyEvent e) {
			code = e.getKeyChar();
		}
	}
}


/*
 * イベント処理
 */
class MenuListener extends WindowAdapter implements ActionListener {
	public MenuBar mb;
	public Menu sys;
	public Menu help;
	public MenuItem sys_reset;
	public MenuItem sys_exit;
	public MenuItem help_ver;
	
	MenuListener() {
		mb = new MenuBar();
	}
	
	void setMenu(Frame f) {
		sys = mb.add(new Menu("システム"));
		sys_reset = sys.add(new MenuItem("リセット"));
		sys_exit = sys.add(new MenuItem("終了"));
		
		help = mb.add(new Menu("ヘルプ"));
		help_ver = help.add(new MenuItem("バージョン"));
		f.setMenuBar(mb);
		
		sys.addActionListener(this);
		help.addActionListener(this);
	}
	
	public void actionPerformed(ActionEvent e) {
		if(e.getActionCommand() == "リセット") {
			chara_table.mode = 1;
		}
		else if(e.getActionCommand() == "終了") {
			System.exit(0);
		}
		else if(e.getActionCommand() == "バージョン") {
			chara_table.mode = 2;
		}
	}
	
	public void runMenu(StringTable st) {
		if(chara_table.mode > 0) {
			st.setNewline("");
			st.setNewline("");
			switch(chara_table.mode) {
			case 1:	// Reset
				chara_table.ViewCharacterList();
				break;
			case 2:	// Version
				st.setNewline(chara_table.TitleFrame);
				st.setNewline("Version "+(String) chara_table.Version);
				
				st.setNewline("");
				st.setNewline("");
				st.setNewline("キャラクターコードを調べたい文字を入力してください。");
				st.setNewline("");
				
				break;
			default:
				break;
			}
		}
		
		chara_table.mode = 0;
	}
}


/*
 * ウィンドウボタン処理
 */
class ExitListener extends WindowAdapter {
	public void windowClosing(WindowEvent e){
		System.exit(0);
	}
}


/*
 * 文字列縦スクロール
 */
class StringTable {
	private String ta[];
	private int NowLine = 0;
	private int MaxLine = 40;
	public final String BR = System.getProperty("line.separator");
	
	// 初期化
	public StringTable(int Max) {
		NowLine = 0;
		setMaxLine(Max);
		ta = new String[MaxLine + 1];
		
		for(int i = 0; i <= MaxLine; i++) { ta[i] = ""; }
	}
	
	// 縦幅指定
	public void setMaxLine(int i) {
		if(i < 1) { i = 20; }
		MaxLine = i;
	}
	
	// 縦幅を返す
	public int getMaxLine() {
		int i = MaxLine;
		return i;
	}
	
	// 文字列追加
	public void setNewline(String line) {
		if(NowLine == MaxLine) {
			for(int i = 0; i < MaxLine; i++) {
				ta[i] = ta[i+1];
			}
		}
		else {
			NowLine++;
		}
		ta[NowLine] = line;
	}
	
	// 指定された表示行に対応する文字列を返す
	public String getLine(int line) {
		String retStr = "";
		if(line <= MaxLine) {
			retStr += ta[line];
		}
			
		return retStr;
	}
}
